club/urls.py
""" Defining URL patterns for registration. """

from django.urls import path

from club.views import ClubView, \
    ActualitiesView, ActualityDetailView, ActualityCreateView, ActualityEditView, \
    DiscussionsView, DiscussionDetailView, DiscussionCreateView, DiscussionEditView, DiscussionReactionView

app_name = 'club'

urlpatterns = [
    # Club main page
    path('', ClubView.as_view(), name='club'),

    # Actualities topics page
    path('actualities/', ActualitiesView.as_view(), name='actualities'),
    # Actuality detail
    path('actuality/<int:id>/', ActualityDetailView.as_view(), name='actuality'),
    # Create new actuality
    path('new_actuality/', ActualityCreateView.as_view(), name='new_actuality'),
    # Edit actuality
    path('edit_actuality/<int:id>/', ActualityEditView.as_view(), name='edit_actuality'),

    # Discussion themes page
    path('discussions/', DiscussionsView.as_view(), name='discussions'),
    # Discussion theme detail
    path('discussion/<int:id>/', DiscussionDetailView.as_view(), name='discussion'),
    # Create new discussion
    path('new_discussion/', DiscussionCreateView.as_view(), name='new_discussion'),
    # Edit discussion theme
    path('edit_discussion/<int:id>/', DiscussionEditView.as_view(), name='edit_discussion'),
    # Reaction on theme in discussion
    path('reaction_discussion/<int:id>/', DiscussionReactionView.as_view(), name='reaction_discussion'),

]

final_project/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include

from warehouse.views import IndexView

urlpatterns = [
    path('admin/', admin.site.urls),

    path('accounts/', include('accounts.urls', namespace='accounts')),
    path('accounts/', include('django.contrib.auth.urls')),

    path('club/', include('club.urls', namespace='club')),

    path('warehouse/', include('warehouse.urls', namespace='warehouse')),

    path('', IndexView.as_view(), name='index'),
]

urlpatterns += (static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
                + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
                )

club/models.py
from django.db.models import CharField, DateTimeField, TextField, ImageField, ForeignKey, Model, PROTECT

from accounts.models import User

# Create your models here.


class Actuality(Model):
    topic = CharField(max_length=512, null=False, blank=False)
    story = TextField(null=False, blank=False)
    image = ImageField(upload_to='actuality', null=True, blank=True)
    created = DateTimeField(null=False, blank=False)
    modified = DateTimeField(auto_now=True)
    author = ForeignKey(User, null=False, on_delete=PROTECT, related_name='actualities')

    def __str__(self):
        return f'{self.topic} [{self.created}]'


class Discussion(Model):
    theme = CharField(max_length=512, null=False, blank=False)
    post = TextField(null=False, blank=False)
    image = ImageField(upload_to='discussion', null=True, blank=True)
    posted = DateTimeField(null=False, blank=False)
    modified = DateTimeField(auto_now=True)
    author = ForeignKey(User, null=False, on_delete=PROTECT, related_name='discussions')
    reaction = ForeignKey('Discussion', on_delete=PROTECT, null=True, blank=True)  # dle generické relace

    def __str__(self):
        return f'{self.theme} [{self.posted}]'

club/forms.py
from django.forms import EmailField, ModelForm, CharField, DateField, ChoiceField, HiddenInput
from club.models import Actuality, Discussion


class ActualityCreateForm(ModelForm):
    """ For creating new actuality. """

    class Meta(ModelForm):
        model = Actuality
        fields = ['topic', 'story', 'image', 'created', 'author']
        widgets = {'created': HiddenInput(), 'author': HiddenInput()}


class DiscussionCreateForm(ModelForm):
    """ For creating new discussion theme. """

    class Meta(ModelForm):
        model = Discussion
        fields = ['theme', 'post', 'image', 'posted', 'author']
        widgets = {'posted': HiddenInput(), 'author': HiddenInput()}


class DiscussionReactionForm(ModelForm):
    """ For creation reaction on theme in discussion. """

    class Meta(ModelForm):
        model = Discussion
        fields = ['theme', 'post', 'posted', 'author', 'reaction']
        widgets = {'theme': HiddenInput(), 'posted': HiddenInput(), 'author': HiddenInput(), 'reaction': HiddenInput()}

club/views.py
from django.forms import HiddenInput
from django.http import Http404
from django.shortcuts import render
from django.urls import reverse_lazy
from django.views.generic import TemplateView, CreateView, DetailView, ListView, UpdateView
from django.contrib.auth.mixins import LoginRequiredMixin
from django.db.models import Q, Sum, Count

from club.models import Actuality, Discussion
from club.forms import ActualityCreateForm, DiscussionCreateForm, DiscussionReactionForm

from datetime import datetime

# Create your views here.


class ClubView(LoginRequiredMixin, ListView):
    """ The home page for Club. Showing last 2 new actualities and last 2 new themes in discussion. """
    template_name = 'club/club.html'
    model = Discussion

    def get_context_data(self, **kwargs):
        context = super().get_context_data()
        context['actualities'] = Actuality.objects.all().order_by('-created')[:2]
        context['discussions'] = Discussion.objects.filter(Q(reaction=None)).order_by('-posted')[:2]
        context['reactions'] = Discussion.objects.filter(~Q(reaction=None)).values('theme', 'reaction').annotate(
            Count('id')).filter(id__count__gt=0)
        return context


class ActualitiesView(LoginRequiredMixin, ListView):
    """ The page for displaying all Actualities. """
    template_name = 'club/actualities.html'
    model = Actuality

    def get_context_data(self, **kwargs):
        context = super().get_context_data()
        context['actualities'] = Actuality.objects.all().order_by('-created')
        return context


class ActualityDetailView(LoginRequiredMixin, DetailView):
    """The page for detail information about Actuality. """
    template_name = 'club/actuality.html'
    model = Actuality

    def get_object(self, queryset=None):
        actuality = Actuality.objects.get(id=self.kwargs['id'])
        return actuality


class ActualityCreateView(LoginRequiredMixin, CreateView):
    """ Create a new Actuality. """
    template_name = 'club/actuality_new.html'
    model = Actuality
    form_class = ActualityCreateForm
    # fields = ['topic', 'story', 'image', 'created', 'author']
    success_url = reverse_lazy('club:actualities')

    def get_initial(self):
        init_data = super().get_initial()
        init_data['author'] = self.request.user.id
        init_data['created'] = datetime.now()
        return init_data


class ActualityEditView(LoginRequiredMixin, UpdateView):
    """ The page for editing existing actuality. """
    template_name = 'club/actuality_edit.html'
    model = Actuality
    form_class = ActualityCreateForm
    success_url = reverse_lazy('club:actualities')

    def get_object(self, queryset=None):
        actuality = Actuality.objects.get(id=self.kwargs['id'])
        user = self.request.user
        if user == actuality.author:
            return actuality
        else:
            raise Http404


class DiscussionsView(LoginRequiredMixin, ListView):
    """ The page for displaying all themes from Discussions. """
    template_name = 'club/discussions.html'
    model = Discussion

    def get_context_data(self, **kwargs):
        context = super().get_context_data()
        context['discussions'] = Discussion.objects.filter(Q(reaction=None)).order_by('-posted')
        context['reactions'] = Discussion.objects.filter(~Q(reaction=None)).values('theme', 'reaction').annotate(
            Count('id')).filter(id__count__gt=0)

        return context


class DiscussionDetailView(LoginRequiredMixin, DetailView):
    """The page for detail information about Discussion. """
    template_name = 'club/discussion.html'
    model = Discussion
    pk_url_kwarg = 'id'

    def get_context_data(self, **kwargs):
        context = super().get_context_data()
        context['discussion'] = Discussion.objects.get(id=self.kwargs['id'])
        context['reactions'] = Discussion.objects.filter(reaction=self.kwargs['id']).order_by('-posted')
        context['sum_reactions'] = len(context['reactions'])
        return context


class DiscussionCreateView(LoginRequiredMixin, CreateView):
    """ Create a new Discussion theme. """
    template_name = 'club/discussion_new.html'
    model = Discussion
    form_class = DiscussionCreateForm
    success_url = reverse_lazy('club:discussions')

    def get_initial(self):
        init_data = super().get_initial()
        init_data['author'] = self.request.user.id
        init_data['posted'] = datetime.now()
        return init_data


class DiscussionEditView(LoginRequiredMixin, UpdateView):
    """ The page for editing existing discussion theme. """
    template_name = 'club/discussion_edit.html'
    model = Discussion
    form_class = DiscussionCreateForm
    success_url = reverse_lazy('club:discussions')

    def get_object(self, queryset=None):
        discussion = Discussion.objects.get(id=self.kwargs['id'])
        user = self.request.user
        if user == discussion.author:
            return discussion
        else:
            raise Http404


class DiscussionReactionView(LoginRequiredMixin, CreateView):
    """ Create a new Reaction on theme in discussion. """
    template_name = 'club/discussion_reaction.html'
    model = Discussion
    form_class = DiscussionReactionForm
    success_url = reverse_lazy('club:discussions')

    def get_initial(self):
        init_data = super().get_initial()
        discussion = Discussion.objects.get(id=self.kwargs['id'])
        init_data['theme'] = discussion.theme
        init_data['author'] = self.request.user.id
        init_data['posted'] = datetime.now()
        init_data['reaction'] = discussion.id
        return init_data

templates/club/actualities.html
<head>
    <title>LSV - Actualities</title>
</head>

{% extends "base.html" %}
{% load static %}

{% block content %}

    <div>
        <h2> Actualities. </h2>
        <div style="text-align: center; margin-top: 10px; margin-bottom: 10px">
            <button onclick='location.href="{% url "club:new_actuality"  %}"' type="button">Create new Actuality</button>
        </div>
        {% for actuality in actualities %}

        <div class="actuality-b">
            <a class="black" href="{% url 'club:actuality' actuality.id %}">
            <div style="text-align: center">
                <h3>{{ actuality.topic }}</h3>
            </div>

            <div class="row justify-content-md-center">
                <div class="col-sm-8">
                    <div style="min-height: 100px">
                        <p style="padding-bottom: 10px">{{ actuality.story|truncatechars:400 }}</p>
                        <div class="actuality-date">
                        <p class="actuality-sign">Created {{ actuality.created|date:'H:i j-n-Y' }} by user {{ actuality.author }}.</p>
                        {% if not actuality.modified == actuality.created %}
                            <p class="actuality-sign">Last modification: {{ actuality.modified|date:'H:i j-n-Y' }}.</p>
                        {% endif %}
                        </div>
                    </div>


                </div>

                <div class="col-sm-4 actuality-image">
                    {% if actuality.image %}
                        <img src="{{ actuality.image.url }}" class="actuality-image" alt="Item image">
                    {% endif %}
                </div>
            </div>
            </a>

        {% if actuality.author == user %}
        <div style="text-align: center; margin-top: 10px; margin-bottom: 10px">
            <button onclick='location.href="{% url "club:edit_actuality" actuality.id %}"' type="button">Edit actuality</button>
        </div>
        {% endif %}

        </div>
        {% endfor %}
    </div>

{% endblock %}

templates/club/actuality.html
<head>
    <title>LSV - Actuality</title>
</head>

{% extends "base.html" %}
{% load static %}

{% block content %}

    <div>
        <h2 class="text-uppercase" style="text-align: center"> {{ actuality.topic}} </h2>

        {% if actuality.author == user %}
        <div style="text-align: center; margin-top: 10px; margin-bottom: 10px">
            <button onclick='location.href="{% url "club:edit_actuality" actuality.id %}"' type="button">Edit actuality</button>
        </div>
        {% endif %}

        <div class="actuality-image-big">
        {% if actuality.image %}
            <img src="{{ actuality.image.url }}" class="actuality-image-big" alt="Item image">
        {% endif %}
        </div>

        <div class="actuality-text">
            <h4 style="text-align: justify">{{ actuality.story}}</h4>
        </div>

        <p style="text-align: right"> Created by: {{ actuality.author }} </p>
        <p style="text-align: right"> Published: {{ actuality.created|date:'j-n-Y (H:i )' }} </p>

        {% if not actuality.modified == actuality.created %}
        <p style="text-align: right"> Modified: {{ actuality.modified|date:'j-n-Y (H:i)' }}</p>
        {% endif %}
    </div>

{% endblock %}

templates/club/actuality_edit.html
{% extends 'base.html' %}

{% block title %}Edit Actuality{% endblock %}

{% block content %}
  <h3>Edit current Actuality</h3>
  <form method="post" enctype="multipart/form-data">
    {% csrf_token %}
    {{ form }}
    <button type="submit">Change Actuality</button>
  </form>
{% endblock %}

templates/club/actuality_new.html
{% extends 'base.html' %}

{% block title %}Create new Actuality{% endblock %}

{% block content %}
  <h3>Create new Actuality</h3>
  <form method="post" enctype="multipart/form-data">
    {% csrf_token %}
    {{ form }}
    <button type="submit">Create Actuality</button>
  </form>
{% endblock %}

templates/club/club.html
<head>
    <title>LSV - Club section</title>
</head>

{% extends "base.html" %}
{% load static %}

{% block content %}
    <div>
        <h1 class="text-uppercase">Club section</h1>
        <p style="text-align: justify">Club section information will be there soon...</p>
    </div>

    <div>
        <h2> Newest two actualities. </h2>
        {% for actuality in actualities %}
        <a class="black" href="{% url 'club:actuality' actuality.id %}">
        <div class="actuality-b">

            <div style="text-align: center">
                <h3>{{ actuality.topic }}</h3>
            </div>

            <div class="row justify-content-md-center">
                <div class="col-sm-8">
                    <div style="min-height: 100px">
                        <p>{{ actuality.story|truncatechars:400 }}</p>
                        <div class="actuality-date">
                        <p class="actuality-sign">Created {{ actuality.created|date:'H:i j-n-Y' }} by user {{ actuality.author }}.</p>
                        {% if not actuality.modified == actuality.created %}
                            <p class="actuality-sign">Last modification: {{ actuality.modified|date:'H:i j-n-Y' }}.</p>
                        {% endif %}
                        </div>
                    </div>
                </div>

                <div class="col-sm-4 actuality-image">
                    {% if actuality.image %}
                        <img src="{{ actuality.image.url }}" class="actuality-image" alt="Item image">
                    {% endif %}
                </div>
            </div>
        </div>
        </a>
        {% endfor %}
        <div style="text-align: center; margin-top: 10px; margin-bottom: 10px">
            <button onclick='location.href="{% url "club:actualities"  %}"' type="button">All Actualities</button>
        </div>
    </div>

    <div>
        <h2> Newest two themes in forum </h2>
        {% for discussion in discussions %}
        <a class="black" href="{% url 'club:discussion' discussion.id %}">
        <div class="actuality-b">

            <div style="text-align: center">
                <h3>{{ discussion.theme }}</h3>
            </div>

            <div class="row justify-content-md-center">
                <div class="col-sm-8">
                    <div style="min-height: 100px">
                        <p>{{ discussion.post|truncatechars:400 }}</p>
                        <div class="actuality-date">
                        <p class="actuality-sign">Created {{ discussion.posted|date:'H:i j-n-Y' }} by user {{ discussion.author }}.</p>
                        {% if not discussion.modified == discussion.posted %}
                            <p class="actuality-sign">Last modification: {{ discussion.modified|date:'H:i j-n-Y' }}.</p>
                        {% endif %}
                        {% for reaction in reactions %}
                            {% if discussion.id == reaction.reaction %}
                            <p class="actuality-sign">Reactions: {{ reaction.id__count }}</p>
                            {% endif %}
                        {% endfor %}
                        </div>
                    </div>
                </div>

                <div class="col-sm-4 actuality-image">
                    {% if discussion.image %}
                        <img src="{{ discussion.image.url }}" class="actuality-image" alt="Item image">
                    {% endif %}
                </div>
            </div>

        </div>
        </a>
        {% endfor %}
        <div style="text-align: center; margin-top: 10px; margin-bottom: 10px">
            <button onclick='location.href="{% url "club:discussions"  %}"' type="button">All Discussions</button>
        </div>
    </div>

{% endblock %}

templates/club/discussion.html
<head>
    <title>LSV - Discussion</title>
</head>

{% extends "base.html" %}
{% load static %}

{% block content %}

    <div>
        <h2 class="text-uppercase" style="text-align: center"> {{ discussion.theme}} </h2>

        {% if discussion.author == user %}
        <div style="text-align: center; margin-top: 10px; margin-bottom: 10px">
            <button onclick='location.href="{% url "club:edit_discussion" discussion.id %}"' type="button">Edit discussion theme</button>
        </div>
        {% endif %}
        <div style="text-align: center; margin-top: 10px; margin-bottom: 10px">
        <button onclick='location.href="{% url "club:reaction_discussion" discussion.id %}"' type="button">React on this theme</button>
        </div>
        <div class="actuality-image-big">
        {% if discussion.image %}
            <img src="{{ discussion.image.url }}" class="actuality-image-big" alt="Item image">
        {% endif %}
        </div>

        <div class="actuality-text">
            <h4 style="text-align: justify">{{ discussion.post}}</h4>
        </div>

        <p style="text-align: right"> Created by: {{ discussion.author }} </p>
        <p style="text-align: right"> Published: {{ discussion.posted|date:'j-n-Y (H:i )' }} </p>

        {% if not discussion.modified == discussion.posted %}
        <p style="text-align: right"> Modified: {{ discussion.modified|date:'j-n-Y (H:i)' }}</p>
        {% endif %}
        <p style="text-align: right"> Number of reactions: {{ sum_reactions }} </p>
    </div>

    <div>
        {% if reactions%}
        <h2 class="text-uppercase" style="text-align: center"> Reactions: </h2>

            {% for reaction in reactions %}
            <div class="actuality-b">
                <div class="actuality-text">
                    <h4>{{ reaction.post}}</h4>
                </div>

                <p style="text-align: right"> Created by: {{ reaction.author }} </p>
                <p style="text-align: right"> Published: {{ reaction.posted|date:'j-n-Y (H:i )' }} </p>

            </div>
            {% endfor %}
        {% endif %}
    </div>

{% endblock %}

templates/club/discussion_edit.html
{% extends 'base.html' %}

{% block title %}Edit Discussion Theme{% endblock %}

{% block content %}
  <h3>Edit current Discussion theme</h3>
  <form method="post" enctype="multipart/form-data">
    {% csrf_token %}
    {{ form }}
    <button type="submit">Change Discussion theme</button>
  </form>
{% endblock %}

templates/club/discussion_new.html
{% extends 'base.html' %}

{% block title %}Create new Discussion theme{% endblock %}

{% block content %}
  <h3>Create new Discussion theme</h3>
  <form method="post" enctype="multipart/form-data">
    {% csrf_token %}
    {{ form }}
    <button type="submit">Create Discussion theme</button>
  </form>
{% endblock %}

templates/club/discussion_reaction.html
{% extends 'base.html' %}

{% block title %}Reaction on theme in discussion{% endblock %}

{% block content %}
  <h3>Create new reaction on theme in discussion</h3>
  <form method="post">
    {% csrf_token %}
    {{ form }}
    <button type="submit">Create a reaction</button>
  </form>
{% endblock %}

templates/club/discussions.html
<head>
    <title>LSV - Forum</title>
</head>

{% extends "base.html" %}
{% load static %}

{% block content %}

    <div>
        <h2> All themes in forum. </h2>
        <div style="text-align: center; margin-top: 10px; margin-bottom: 10px">
            <button onclick='location.href="{% url "club:new_discussion"  %}"' type="button">Create new Discussion theme</button>
        </div>
        {% for discussion in discussions %}

        <div class="actuality-b">
            <a class="black" href="{% url 'club:discussion' discussion.id %}">
            <div style="text-align: center">
                <h3>{{ discussion.theme }}</h3>
            </div>

            <div class="row justify-content-md-center">
                <div class="col-sm-8">
                    <div style="min-height: 100px">
                        <p>{{ discussion.post|truncatechars:400 }}</p>
                        <div class="actuality-date">
                        <p class="actuality-sign">Created {{ discussion.posted|date:'H:i j-n-Y' }} by user {{ discussion.author }}.</p>
                        {% if not discussion.modified == discussion.posted %}
                            <p class="actuality-sign">Last modification: {{ discussion.modified|date:'H:i j-n-Y' }}.</p>
                        {% endif %}
                        {% for reaction in reactions %}
                            {% if discussion.id == reaction.reaction %}
                            <p class="actuality-sign">Reactions: {{ reaction.id__count }}</p>
                            {% endif %}
                        {% endfor %}
                        </div>
                    </div>


                </div>

                <div class="col-sm-4 actuality-image">
                    {% if discussion.image %}
                        <img src="{{ discussion.image.url }}" class="actuality-image" alt="Item image">
                    {% endif %}
                </div>
            </div>
            </a>

        {% if discussion.author == user %}
        <div style="text-align: center; margin-top: 10px; margin-bottom: 10px">
            <button onclick='location.href="{% url "club:edit_discussion" discussion.id %}"' type="button">Edit discussion theme</button>
        </div>
        {% endif %}

        </div>
        {% endfor %}
    </div>


{% endblock %}